import java.util.*;
import java.io.* ;
import java.net.* ;
import java.sql.*;
import java.lang.*;
import java.util.Properties;
import java.util.Vector;
import javax.swing.text.html.parser.*;



public class MonCrawler {



	// Fichier de journalisation ou sera inscrit le rapport des operations effectuees

   	static File fichierLog ;

	private BufferedWriter bw = null;

	private FileWriter fw = null;

	// Tableau contenant toutes les pages avec leurs liens

    	public TabURI tab;

	// Vecteur contenant les liens visites (il va nous servir pour le parcours recursif et la profondeur)
    	public TabPageAPaser vecteurLiens;

	// Vecteur contenant les liens visites (il va nous permettre d'eviter de parser une page deja visitee)
	public TabLiensVisites PageDejaVisitee;

	// Racine contenu dans le fichier de configuration crawler.conf
	static String urlRacine;

	// La profondeur contenu dans le fichier de configuration crawler.conf
	int profondeur;

	//Chemin absolue de la racine necessaire au traitement des urls au cas ou un chemin relatif est trouve
	static String urlChemin;

	//Variable pour la connexion a la base de donnes
    	private static Connection connection=null;

	//Option "--init"
	static boolean optionInit=false;

	//Option "--img"
	static boolean optionImage=false;

	//Option "--mail"
	static boolean optionMail=false;



	

	///////////////////////////////////////////////////////////////////////////////////
	// -------------------------------- construteur -------------------------------- //
	///////////////////////////////////////////////////////////////////////////////////

	/* On va d'abord recuperer les parametres du fichier de configuration donn en argument.
	Puis on cree le fichier de journalisation "crawler.log" dans lequel nous allons mettre 
	toutes les liens trouvs. */
	

	public MonCrawler(String fichierConfig){




		try{


			//On recupere les parametres definis dans le fichier de configuration.
			Properties p = new Properties();
			p.load(new FileInputStream(new File(fichierConfig)));
			urlRacine = p.getProperty("urlRacine");
			profondeur =  Integer.parseInt(p.getProperty("profondeur"));


			//On affiche les parametres de configuration.
			System.out.println("L'adresse de depart est: " + p.getProperty("urlRacine"));
			System.out.println("La profondeur est: " + profondeur);


			//On stocke dans une variable String le chemin absolue de la racine
			int position = urlRacine.lastIndexOf("/");
			if(position==-1){
				System.out.println("Erreur: le chemin de la racine est mal definie, verifier que le fichier de configuration contient un chemin absolue pour la racine");
				System.exit(0);
			}
			urlChemin = urlRacine.substring(0,position+1);
			System.out.println("urlChemin:" + urlChemin);


			//Cration du fichier Log.

			fichierLog = new File(".","crawler.log") ;

			fw = new FileWriter(fichierLog);

			bw = new BufferedWriter(fw);

		}

		catch(IOException e) { System.out.println("Erreur E/S:" + e); }



	}







	///////////////////////////////////////////////////////////////////////////////////
	// --------------------------------    MAIN     -------------------------------- //
	///////////////////////////////////////////////////////////////////////////////////

	/* On verifie que le fichierde configuration est donn en parametre. 
	On enregiste ensuite les options donn en arguments.
	Enfin on lance notre explorateur. */

    	public static void main (String args[]) throws IOException {


		String fichierConfiguration="";


		//On verifie que le fichier de configuration est pass en parametre.

		if(args.length < 1){

			System.out.println("\nUsage : java MonCrawler <fichier.conf> <--options>");
			System.exit(1);

		}

		//On prends en compte les options.
		for(int i=0;i<args.length;i++) {

			if(args[i].equals("--init"))
				optionInit=true;
			if(args[i].equals("--img"))
				optionImage=true;
			if(args[i].equals("--mail"))
				optionMail=true;
			if(args[i].endsWith(".conf"))
				fichierConfiguration=args[0];

		}

		//On verifie que le fichier de configuration est pass en parametre.

		if(fichierConfiguration.equals("")){

			System.out.println("\nUsage : Vous n'avez pas entr le fichier de configuration en arguments");
			System.out.println("\nUsage : java MonCrawler <fichier.conf> <--options>");
			System.exit(1);

		}


		//Pas d'option: par defaut c'est egale a : --init --mail --img.

		if(args.length == 1){
			optionInit=true;
			optionMail=true;

			optionImage=true;

		}

		

		//On lance le crawler.

		MonCrawler mc = new MonCrawler(fichierConfiguration);
		mc.Explore();
		System.out.println("            ----------------------            ");
		System.out.println("-----------<   FIN DU PROGRAMME   >-----------");
		System.out.println("            ----------------------            ");
		



	}










	///////////////////////////////////////////////////////////////////////////////////
	// ------------------------------ fonction Explore ----------------------------- //
	///////////////////////////////////////////////////////////////////////////////////

	
	/* Fonction qui va parser la racine. Elle va ensuite inserer les informations recueillies
	 dans la base et aussi les ecrire dans le fichier de journalisation.
	Elle fait enfin appel  la fonction recursive "parcoursLargeur()".*/
	
	public void Explore() throws IOException, FileNotFoundException {



		InputStream InFile;
		AdresseURI adr;


		try {
			//On se connecte a la base de donnes
			ConnectionBDD();
			//On vide la base de donnes
			videBDD();



			//On parse la racine et on appelle la fonction recursive pour parser les autres pages
			URL url;
	    		url = new URL(urlRacine);

			
	    		URLConnection temp = url.openConnection();	    
	    		InFile = (InputStream) temp.getContent();

	   		BufferedReader rdr = new BufferedReader(new InputStreamReader(InFile));


			tab = new TabURI();

			tab.setUrlDepart (urlRacine);
			adr = new AdresseURI(urlRacine,"lien","je suis la racine");
			tab.inser(adr);

			vecteurLiens = new TabPageAPaser();
			vecteurLiens.inser(urlRacine);
			vecteurLiens.inser("*");

			PageDejaVisitee = new TabLiensVisites();
			PageDejaVisitee.inser(urlRacine);



			//Remplissage du fichier de journalisation
			FichierJournalisation("\r\nDebut du parsing:\r\n\tURL Graine: "+urlRacine+"\r\n\tprofondeur: "+profondeur+"\r\n\r\n\r\n");

			//Parcours de la racine	
			CrawlerCallbackHandler handler = new CrawlerCallbackHandler(tab,vecteurLiens,PageDejaVisitee,urlChemin,optionImage,optionMail);
        		new ParserDelegator().parse(rdr, handler, true);  

			//On enregistre les donnees de tab dans le fichier de journalisation
			AfficheFichierJournalisation();
			//On enregistre les donnees de tab dans la base de donnes
			insertionBDD();



			//Fonction recursive
			parcoursLargeur();



		  }



		catch (Exception e) {

		    System.err.println("Erreur : " + e);

		    System.exit(0);

		}


	} // fin Explore






	///////////////////////////////////////////////////////////////////////////////////
	// ------------------------------ fonction d'exploration recursive-------------- //
	///////////////////////////////////////////////////////////////////////////////////

	/* La fonction "parcoursLargeur()" va d'abord vrifier la profondeur  laquel 
	on se trouve. 
	Si on a fini le parcours sur la profondeur dfinie dans les parametres de configuration, 
	on s'arrete ( la variable profondeur est inferieur a 0). 
	Si on change de profondeur, c'est--dire si on rencontre le symbole "*" dans le 
	premier element de "vecteurLiens", on baisse de 1 la valeur de profondeur. Puis on fait 
	 de nouveau appel a la recursivit.
	Sinon, on effectue les memes operations que la fonction "Exlpore()". On parcours la page
	 HTML qui se trouve dans le premier element de "vecteurLiens". Puis on fait appel a la 
	 recursivit.*/
	

	private void parcoursLargeur()
	{

		String pageAParcourir;


	    	if (profondeur < 0)
			return;

		vecteurLiens.supprimerPremier();
		vecteurLiens.afficheContenu();
		pageAParcourir = (String)vecteurLiens.lesurls.get(0);	
		
		if (pageAParcourir.equals("*"))
		{
			profondeur --;
			vecteurLiens.inser("*");
			vecteurLiens.afficheContenu();
		}		
		else {

			
			System.out.println("============> " + pageAParcourir);

			try {
				InputStream InFile;
    				URL url;
    				url = new URL(pageAParcourir);
    				URLConnection temp = url.openConnection();
    				InFile = (InputStream) temp.getContent();

   				BufferedReader rdr = new BufferedReader(new InputStreamReader(InFile)); 
		

				tab = new TabURI();
				//vecteurLiens = new TabPageAPaser();
				tab.setUrlDepart (pageAParcourir);

				//Lancement du parsage
				CrawlerCallbackHandler handler = new CrawlerCallbackHandler(tab,vecteurLiens,PageDejaVisitee,urlChemin,optionImage,optionMail);
   				new ParserDelegator().parse(rdr, handler, true);


				//On enregistre les donnees de tab dans le fichier de journalisation
				AfficheFichierJournalisation();
				//On enregistre les donnees de tab dans la base de donnes
				insertionBDD();
				

	  		}



			catch (Exception e) {

	    			System.err.println("Erreur : Impossible de parser la page :" + e);

	    			System.exit(0);

			}

		}
	    		
		parcoursLargeur();

	}



    



















	///////////////////////////////////////////////////////////////////////////////////
	//                 Fonctions pour la gestion de la base de donnes               //
	///////////////////////////////////////////////////////////////////////////////////


	//Fonction qui ouvre une connexion avec la base de donnes

	public void ConnectionBDD() throws SQLException {



		//Connection connection=null;

	

		try {
	
		//Charger de driver MM.Mysql
		Class.forName("org.gjt.mm.mysql.Driver");
		//connexion
		String uriConnection = "jdbc:mysql://localhost/projet";
		String login ="root";

		String passwd = "";	
		connection = DriverManager.getConnection(uriConnection,login,passwd);
		}
		catch (Exception e) {
        	System.out.println("Erreur connection a la BDD: "+e.getMessage());
		}
	

		System.out.println("Connection a la BDD reussie");
		
	}

	//Fonction qui ferme la connexion avec la base de donnes
	public static void deconnectionBDD() throws SQLException {
		//fermeture de la connection
		connection.close();
		System.out.println("Deconnection a la BDD reussie");
	}


	//Fonction qui va vider la base de donnes
	private void videBDD() throws SQLException {
		String msg = null;
		PreparedStatement pst = null;
		
		try
		{

			msg = "DELETE FROM uri";
	    		pst = connection.prepareStatement(msg);
			pst.executeUpdate();

			
			msg = "DELETE FROM motclef";
	    		pst = connection.prepareStatement(msg);
			pst.executeUpdate();
			
			msg = "DELETE FROM uri_motclef";
	    		pst = connection.prepareStatement(msg);
			pst.executeUpdate();
			
			
		}
		catch(Exception e) {
			System.out.println("Erreur fonction videBDD() :"+ e.getMessage());
	    }

		System.out.println("Base de donnes vide.");
	}







	//Fonction qui gere les insertions dans la base de donnes.
	public void insertionBDD() {

		int idURI, idMot;
		String leMotCourant = null;
		Vector lesMots=null;
		int taille,i;

		Object obj;

		AdresseURI adresse;

		try {

			taille = tab.size();

			//Pour chaque URI contenu dans "tab", on insere ses informations dans la base de donnes.
			for (i=0 ; i<taille ; i++) {

	    			obj = tab.get(i);

	    			adresse = (AdresseURI)obj;

				//On insere l'uri en cours et on enregistre son identifiant dans la base dans une variable.
				idURI = insertionURIBDD(adresse);
				
				//On coupe la chaine "adresse.getAdresseInfo()" en mots
				//que l'on met dans le vecteur "lesMots".
				lesMots = separeMotsClefs(adresse.getAdresseInfo());

				//On insere chaque mot contenu dans le vecteur dans la base de donnes.
				Enumeration lesMotsClefs = lesMots.elements();
				while(lesMotsClefs.hasMoreElements()){
					leMotCourant = (String)lesMotsClefs.nextElement();
					idMot = insertionMotBDD(leMotCourant);

					//Insertion du lien entre la table uri et motclef
					insertionURIMotBDD(idURI,idMot);

				}


			}
		}
		catch (Exception e) {
        	System.err.println("Erreur insertionBDD : "+e);
		}
	}









	// La fonction insere l'adresse uri donn en parametre dans la base de donnes.
	// Elle retourne l'identifiant de l'uri insr.
	public int insertionURIBDD(AdresseURI adresse) {

		int typeLien=-1;


		//Table uri
		String msguri = null;
		PreparedStatement psturi = null;

		try {


			//On insere dans la base de donnees l'uri
			msguri = "INSERT INTO uri VALUES (?,?,?)";
		    	psturi = connection.prepareStatement(msguri);

			if(adresse.getAdresseType().equals("lien"))

	    			typeLien = 0;

			else if(adresse.getAdresseType().equals("image"))

	    			typeLien = 1;

			else if(adresse.getAdresseType().equals("mail"))

	    			typeLien = 2;

			else {	
				System.out.println("type de lien non reference");

	    			System.exit(0); 
			}

	
			//insertion des uris
			//if(typeLien == 0){
			//On execute la requete d'insertion
   			psturi.setString(1,null);
   			psturi.setString(2,adresse.getAdresseUri());
			psturi.setInt(3,typeLien);
   			psturi.executeUpdate();

			return recupIdURIBDD(adresse.getAdresseUri());
			//}
		}
		catch (SQLException e) {
			// On rcupre de l'identifiant de l'uri deja prsent dans la base.
			return recupIdURIBDD(adresse.getAdresseUri());
		}
	}









	//Fonction qui retourne l'identifiant de l'URI donn en parametre
	private int recupIdURIBDD(String uri)
	{
		//Table uri
		String msguri = null;
		PreparedStatement psturi = null;
		ResultSet resultat = null;

	
		try
		{

		//On dfinit la requete
	    	msguri = "SELECT id_uri FROM uri WHERE uri = ?";
		psturi = connection.prepareStatement(msguri);

		//On execute la requete
   		psturi.setString(1,uri);
		resultat = psturi.executeQuery();
		while (resultat.next())
		{
			return resultat.getInt("id_uri");
		}
		return -1;
		}
		catch(SQLException e)
	    	{
			System.out.println("Erreur recupIdURIBDD :"+ e);
			return -1;
	    	}

	}












	// La fonction insere le mot donn en parametre dans la base de donnes.
	// Elle retourne l'identifiant du mot insr (ou dj prsent dans la base).
	private int insertionMotBDD(String mot)
	{
		String msgmotclef = null;
		PreparedStatement pstmotclef = null;
		
		try
		{

		//On insere dans la base de donnees un mot clef
	    	msgmotclef = "INSERT INTO motclef (motclef) VALUES (?)";

	    	pstmotclef = connection.prepareStatement(msgmotclef);
	    	pstmotclef.setString(1, mot);
		pstmotclef.executeUpdate();	
			
		// On rcupre l'identifiant du mot insr.
		return recupIdMotBDD(mot);
		}
		//Echec lors de l'insertion : le mot se trouve dj dans la base de donnes.
		catch(SQLException e)
	    	{
			// On rcupre de l'identifiant du mot prsent dans la base.
			return recupIdMotBDD(mot);
	    	}
	}








	//Fonction qui retourne l'identifiant du mot donn en parametre
	private int recupIdMotBDD(String mot)
	{
		//Table motclef
		String msgmotclef = null;
		PreparedStatement pstmotclef = null;
		ResultSet resultat = null;

	
		try
		{

		//On dfinit la requete
	    	msgmotclef = "SELECT id_motclef FROM motclef WHERE motclef = ?";
		pstmotclef = connection.prepareStatement(msgmotclef);

		//On execute la requete
   		pstmotclef.setString(1,mot);
		resultat = pstmotclef.executeQuery();
		while (resultat.next())
		{
			return resultat.getInt("id_motclef");
		}
		return -1;
		}
		catch(SQLException e)
	    	{
			System.out.println("Erreur recupIdMotBDD :"+ e);
			return -1;
	    	}

	}







	// La fonction insere le lien entre une uri et ses mots clfs dans la base de donnes.
	private void insertionURIMotBDD(int idURI, int idMot)
	{
		String msg = null;
		PreparedStatement pst = null;
		
		try
		{
	    	msg = "INSERT IGNORE INTO uri_motclef VALUES (?,?)";

	    	pst = connection.prepareStatement(msg);

	    	pst.setInt(1, idURI);
		pst.setInt(2, idMot);
		pst.executeUpdate();
		}
		catch(SQLException e)
	    {
			System.out.println("Erreur insertionURIMotBDD :"+ e);
	    }
	}



























	//Fonction qui va nous permettre de separer les mots clefs
	public Vector separeMotsClefs(String mots)
	{
		Vector vecteursMots = new Vector();
		int position1 = 0; // Dbutdu mot
		int position2=0; // Fin du mot

		String s=mots.trim(); // On enleve les espaces inutiles
		s=s+" "; // On ajoute un espace a la fin de s pour pouvoir enregistrer le dernier mot de la chaine


		while((position2 = s.indexOf(" ",position1)) != -1) {

			//position2 = s.indexOf(" ",position1);
			if(!s.substring(position1,position2).equals(""))
				vecteursMots.add(s.substring(position1,position2));
			position1 = position2 + 1;

		}


		return vecteursMots;
			      
	}















































	///////////////////////////////////////////////////////////////////////////////////
	//            Fonctions pour le fichier de journalisation "crawler.log           //
	///////////////////////////////////////////////////////////////////////////////////

	//Fonction FichierJournalisation(String msg)
	//On va rentrer dans le fichier Crawler.log toutes les liens trouves
	public void FichierJournalisation(String msg) {



		try {
			bw.write((new java.util.Date()).toString());
			bw.write('\t');
			bw.write(msg);
			bw.write("\r\n");
			bw.flush();
		}
		catch (IOException e) {
        	System.err.println("Erreur : "+e);
		}
		
	}




	// Fichier de journalisation ou sera inscrit le rapport des operations effectuees

    	public void AfficheFichierJournalisation() {

		int taille,i;

		Object obj;

		AdresseURI adresse;



		try {
			bw.write(">> URL de depart : " + tab.urlDepart);
			bw.write('\t');
			taille = tab.size();
			bw.write(" nb adresses trouves = " + taille);
			bw.write("\r\n\r\n");
			

			for (i=0 ; i<taille ; i++) {

	    			obj = tab.get(i);

	    			adresse = (AdresseURI)obj;

	    			bw.write("===> nom: " + adresse.getAdresseInfo() + "\r\n");

	    			bw.write("===> uri: " + adresse.getAdresseUri() + "\r\n");

	    			bw.write("===> type: " + adresse.getAdresseType() + "\r\n");

	    			bw.write("---------------------------------------\r\n");

			}
			bw.write("\r\n\r\n");
			bw.flush();
		}
		catch (IOException e) {
        	System.err.println("Erreur : "+e);
		}



    }






}





